#include <iostream>

auto timesObject( int value ) {
    return [&]( int n ) { return n * value; };
}

int main() {
    auto times2 = timesObject( 2 );
    auto times3 = timesObject( 3 );

    int result2 = times2( 10 );
    int result3 = times3( 10 );

    std::cout << result2 << std::endl; // 20
    std::cout << result3 << std::endl; // 30
    std::cout << times2( 3 ) << std::endl; // 6
}
